---
title: Proxy Auto-Configuration (PAC) file
slug: Web/HTTP/Proxy_servers_and_tunneling/Proxy_Auto-Configuration_(PAC)_file
tags:
  - Necko
  - Networking
  - PAC
  - Proxy
---
<div>{{HTTPSidebar}}</div>

<p>A <strong>Proxy Auto-Configuration (PAC)</strong> file is a JavaScript function that determines whether web browser requests (HTTP, HTTPS, and FTP) go directly to the destination or are forwarded to a web proxy server. The JavaScript function contained in the PAC file defines the function:</p>

<pre class="brush: js notranslate">function FindProxyForURL(url, host) {
  // ...
}</pre>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">function FindProxyForURL(<var>url</var>, <var>host</var>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>url</var></code></dt>
 <dd>The URL being accessed. The path and query components of <code>https://</code> URLs are stripped. In Chrome (versions 52 to 73), you can disable this by setting <code>PacHttpsUrlStrippingEnabled</code> to <code>false</code> in policy or by launching with the <code>--unsafe-pac-url</code> command-line flag (in Chrome 74, only the flag works, and from 75 onward, there is no way to disable path-stripping; as of Chrome 81, path-stripping does not apply to HTTP URLs, but there is interest in changing this behavior to match HTTPS); in Firefox, the preference is <code>network.proxy.autoconfig_url.include_path</code>.</dd>
 <dt><code><var>host</var></code></dt>
 <dd>The hostname extracted from the URL. This is only for convenience; it is the same string as between <code>://</code> and the first <code>:</code> or <code>/</code> after that. The port number is not included in this parameter. It can be extracted from the URL when necessary.</dd>
</dl>

<h2 id="Description">Description</h2>

<p>Returns a string describing the configuration. The format of this string is defined in <strong>return value format</strong> below.</p>

<h3 id="Return_value_format">Return value format</h3>

<ul>
 <li>The JavaScript function returns a single string</li>
 <li>If the string is null, no proxies should be used</li>
 <li>The string can contain any number of the following building blocks, separated by a semicolon:</li>
</ul>

<dl>
 <dt><code>DIRECT</code></dt>
 <dd>Connections should be made directly, without any proxies</dd>
 <dt><code>PROXY <em>host:port</em></code></dt>
 <dd>The specified proxy should be used</dd>
 <dt><code>SOCKS <em>host:port</em></code></dt>
 <dd>The specified SOCKS server should be used</dd>
</dl>

<p>Recent versions of Firefox support as well:</p>

<dl>
 <dt><code>HTTP <em>host:port</em></code></dt>
 <dd>The specified proxy should be used</dd>
 <dt><code>HTTPS <em>host:port</em></code></dt>
 <dd>The specified HTTPS proxy should be used</dd>
 <dt><code>SOCKS4 <em>host:port</em></code></dt>
 <dt><code>SOCKS5 <em>host:port</em></code></dt>
 <dd>The specified SOCKS server (with the specified SOCK version) should be used</dd>
</dl>

<p>If there are multiple semicolon-separated settings, the left-most setting will be used, until Firefox fails to establish the connection to the proxy. In that case, the next value will be used, etc.</p>

<p>The browser will automatically retry a previously unresponsive proxy after 30 minutes. Additional attempts will continue beginning at one hour, always adding 30 minutes to the elapsed time between attempts.</p>

<p>If all proxies are down, and there was no DIRECT option specified, the browser will ask if proxies should be temporarily ignored, and direct connections attempted. After 20 minutes, the browser will ask if proxies should be retried, asking again after an additional 40 minutes. Queries will continue, always adding 20 minutes to the elapsed time between queries.</p>

<h4 id="Examples">Examples</h4>

<dl>
 <dt><code>PROXY w3proxy.netscape.com:8080; PROXY mozilla.netscape.com:8081</code></dt>
 <dd>Primary proxy is w3proxy:8080; if that goes down start using mozilla:8081 until the primary proxy comes up again.</dd>
 <dt><code>PROXY w3proxy.netscape.com:8080; PROXY mozilla.netscape.com:8081; DIRECT</code></dt>
 <dd>Same as above, but if both proxies go down, automatically start making direct connections. (In the first example above, Netscape will ask user confirmation about making direct connections; in this case, there is no user intervention.)</dd>
 <dt><code>PROXY w3proxy.netscape.com:8080; SOCKS socks:1080</code></dt>
 <dd>Use SOCKS if the primary proxy goes down.</dd>
</dl>

<p id="Saving_the_Auto-Config_File_Setting_the_MIME_Type">The auto-config file should be saved to a file with a .pac filename extension:</p>

<pre class="syntaxbox notranslate">proxy.pac</pre>

<p>And the MIME type should be set to:</p>

<pre class="syntaxbox notranslate">application/x-ns-proxy-autoconfig</pre>

<p>Next, you should configure your server to map the .pac filename extension to the MIME type.</p>

<div class="note">
<p><strong>Notes: </strong></p>

<ul>
 <li>The JavaScript function should always be saved to a file by itself but not be embedded in a HTML file or any other file.</li>
 <li>The examples at the end of this document are complete. There is no additional syntax needed to save it into a file and use it. (Of course, the JavaScripts must be edited to reflect your site's domain name and/or subnets.)</li>
</ul>
</div>

<h2 id="Predefined_functions_and_environment">Predefined functions and environment</h2>

<p>These functions can be used in building the PAC file:</p>

<ul>
 <li>Hostname based conditions
  <ul>
   <li><code><a href="#isPlainHostName">isPlainHostName()</a></code></li>
   <li><code><a href="#dnsDomainIs">dnsDomainIs()</a></code></li>
   <li><code><a href="#localHostOrDomainIs">localHostOrDomainIs()</a></code></li>
   <li><code><a href="#isResolvable">isResolvable()</a></code></li>
   <li><code><a href="#isInNet">isInNet()</a></code></li>
  </ul>
 </li>
 <li>Related utility functions
  <ul>
   <li><code><a href="#dnsResolve">dnsResolve()</a></code></li>
   <li><code><a href="#convert_addr">convert_addr()</a></code></li>
   <li><code><a href="#myIpAddress">myIpAddress()</a></code></li>
   <li><code><a href="#dnsDomainLevels">dnsDomainLevels()</a></code></li>
  </ul>
 </li>
 <li>URL/hostname based conditions
  <ul>
   <li><code><a href="#shExpMatch">shExpMatch()</a></code></li>
  </ul>
 </li>
 <li>Time based conditions
  <ul>
   <li><code><a href="#weekdayRange">weekdayRange()</a></code></li>
   <li><code><a href="#dateRange">dateRange()</a></code></li>
   <li><code><a href="#timeRange">timeRange()</a></code></li>
  </ul>
 </li>
 <li>Logging utility
  <ul>
   <li>{{domxref("Window/alert", "alert()")}}</li>
  </ul>
 </li>
 <li>There was one associative array (object) already defined, because at the time JavaScript code was unable to define it by itself:
  <ul>
   <li><code>ProxyConfig.bindings</code> {{obsolete_inline}}</li>
  </ul>
 </li>
</ul>

<div class="note">
<p><strong>Note:</strong> pactester (part of the <a href="https://github.com/pacparser/pacparser">pacparser </a>package) was used to test the following syntax examples.</p>

<ul>
 <li>The PAC file is named <code>proxy.pac</code></li>
 <li>Command line: <code>pactester -p ~/pacparser-master/tests/proxy.pac -u http://www.mozilla.org</code> (passes the <code>host</code> parameter <code>www.mozilla.org</code> and the <code>url</code> parameter <code>http://www.mozilla.org</code>)</li>
</ul>
</div>

<h3 id="isPlainHostName">isPlainHostName()</h3>

<h4 id="Syntax_2">Syntax</h4>

<pre class="syntaxbox notranslate">isPlainHostName(<var>host</var>)</pre>

<h4 id="Parameters_2">Parameters</h4>

<dl>
 <dt>host</dt>
 <dd>The hostname from the URL (excluding port number).</dd>
</dl>

<h4 id="Description_2">Description</h4>

<p>True if and only if there is no domain name in the hostname (no dots).</p>

<h4 id="Examples_2">Examples</h4>

<pre class="brush: js notranslate">isPlainHostName("www.mozilla.org") // false
isPlainHostName("www") // true
</pre>

<h3 id="dnsDomainIs"><code>dnsDomainIs()</code></h3>

<h4 id="Syntax_3">Syntax</h4>

<pre class="syntaxbox notranslate">dnsDomainIs(<var>host</var>, <var>domain</var>)</pre>

<h4 id="Parameters_3">Parameters</h4>

<dl>
 <dt>host</dt>
 <dd>Is the hostname from the URL.</dd>
 <dt>domain</dt>
 <dd>Is the domain name to test the hostname against.</dd>
</dl>

<h4 id="Description_3">Description</h4>

<p>Returns true if and only if the domain of hostname matches.</p>

<h4 id="Examples_3">Examples</h4>

<pre class="brush: js notranslate">dnsDomainIs("www.mozilla.org", ".mozilla.org") // true
dnsDomainIs("www", ".mozilla.org") // false
</pre>

<h3 id="localHostOrDomainIs">localHostOrDomainIs()</h3>

<h4 id="Syntax_4">Syntax</h4>

<pre class="syntaxbox notranslate">localHostOrDomainIs(<var>host</var>, <var>hostdom</var>)</pre>

<h4 id="Parameters_4">Parameters</h4>

<dl>
 <dt>host</dt>
 <dd>The hostname from the URL.</dd>
 <dt>hostdom</dt>
 <dd>Fully qualified hostname to match against.</dd>
</dl>

<h4 id="Description_4">Description</h4>

<p>Is true if the hostname matches <em>exactly</em> the specified hostname, or if there is no domain name part in the hostname, but the unqualified hostname matches.</p>

<h4 id="Examples_4">Examples</h4>

<pre class="brush: js notranslate">localHostOrDomainIs("www.mozilla.org" , "www.mozilla.org") // true (exact match)
localHostOrDomainIs("www"             , "www.mozilla.org") // true (hostname match, domain not specified)
localHostOrDomainIs("www.google.com"  , "www.mozilla.org") // false (domain name mismatch)
localHostOrDomainIs("home.mozilla.org", "www.mozilla.org") // false (hostname mismatch)</pre>

<h3 id="isResolvable">isResolvable()</h3>

<h4 id="Syntax_5">Syntax</h4>

<pre class="syntaxbox notranslate">isResolvable(<var>host</var>)</pre>

<h4 id="Parameters_5">Parameters</h4>

<dl>
 <dt>host</dt>
 <dd>is the hostname from the URL.</dd>
</dl>

<p>Tries to resolve the hostname. Returns true if succeeds.</p>

<h4 id="Examples_5">Examples:</h4>

<pre class="brush: js notranslate">isResolvable("www.mozilla.org") // true
</pre>

<h3 id="isInNet">isInNet()</h3>

<h4 id="Syntax_6">Syntax</h4>

<pre class="syntaxbox notranslate">isInNet(<var>host</var>, <var>pattern</var>, <var>mask</var>)</pre>

<h4 id="Parameters_6">Parameters</h4>

<dl>
 <dt>host</dt>
 <dd>a DNS hostname, or IP address. If a hostname is passed, it will be resolved into an IP address by this function.</dd>
 <dt>pattern</dt>
 <dd>an IP address pattern in the dot-separated format.</dd>
 <dt>mask</dt>
 <dd>mask for the IP address pattern informing which parts of the IP address should be matched against. 0 means ignore, 255 means match.</dd>
</dl>

<p>True if and only if the IP address of the host matches the specified IP address pattern.</p>

<p>Pattern and mask specification is done the same way as for SOCKS configuration.</p>

<h4 id="Examples_6">Examples:</h4>

<pre class="brush: js notranslate">function alert_eval(str) { alert(str + ' is ' + eval(str)) }
function FindProxyForURL(url, host) {
  alert_eval('isInNet(host, "63.245.213.24", "255.255.255.255")')
  // "PAC-alert: isInNet(host, "63.245.213.24", "255.255.255.255") is true"
}
</pre>

<h3 id="dnsResolve">dnsResolve()</h3>

<pre class="syntaxbox notranslate">dnsResolve(<em>host</em>)</pre>

<h4 id="Parameters_7">Parameters</h4>

<dl>
 <dt>host</dt>
 <dd>hostname to resolve.</dd>
</dl>

<p>Resolves the given DNS hostname into an IP address, and returns it in the dot-separated format as a string.</p>

<h4 id="Example">Example</h4>

<pre class="brush: js notranslate">dnsResolve("www.mozilla.org"); // returns the string "104.16.41.2"</pre>

<h3 id="convert_addr">convert_addr()</h3>

<h4 id="Syntax_7">Syntax</h4>

<pre class="syntaxbox notranslate">convert_addr(ipaddr)</pre>

<h4 id="Parameters_8">Parameters</h4>

<dl>
 <dt>ipaddr</dt>
 <dd>Any dotted address such as an IP address or mask.</dd>
</dl>

<p>Concatenates the four dot-separated bytes into one 4-byte word and converts it to decimal.</p>

<h4 id="Example_2">Example</h4>

<pre class="brush: js notranslate">convert_addr("104.16.41.2"); // returns the decimal number 1745889538</pre>

<h3 id="myIpAddress">myIpAddress()</h3>

<h4 id="Syntax_8">Syntax</h4>

<pre class="syntaxbox notranslate">myIpAddress()</pre>

<h4 id="Parameters_9">Parameters</h4>

<p><strong>(none)</strong></p>

<p>Returns the server IP address of the machine Firefox is running on, as a string in the dot-separated integer format.</p>

<div class="warning">
<p>myIpAddress() returns the same IP address as the server address returned by <strong><code>nslookup localhost</code> </strong>on a Linux machine. It does not return the public IP address.</p>
</div>

<h4 id="Example_3">Example</h4>

<pre class="brush: js notranslate">myIpAddress() //returns the string "127.0.1.1" if you were running Firefox on that localhost</pre>

<h3 id="dnsDomainLevels">dnsDomainLevels()</h3>

<h4 id="Syntax_9">Syntax</h4>

<pre class="syntaxbox notranslate">dnsDomainLevels(<var>host</var>)</pre>

<h4 id="Parameters_10">Parameters</h4>

<dl>
 <dt>host</dt>
 <dd>is the hostname from the URL.</dd>
</dl>

<p>Returns the number (integer) of DNS domain levels (number of dots) in the hostname.</p>

<h4 id="Examples_7">Examples:</h4>

<pre class="brush: js notranslate">dnsDomainLevels("www");             // 0
dnsDomainLevels("mozilla.org");     // 1
dnsDomainLevels("www.mozilla.org"); // 2
</pre>

<h3 id="shExpMatch">shExpMatch()</h3>

<h4 id="Syntax_10">Syntax</h4>

<pre class="syntaxbox notranslate">shExpMatch(<var>str</var>, <var>shexp</var>)</pre>

<h4 id="Parameters_11">Parameters</h4>

<dl>
 <dt>str</dt>
 <dd>is any string to compare (e.g. the URL, or the hostname).</dd>
 <dt>shexp</dt>
 <dd>is a shell expression to compare against.</dd>
</dl>

<p>Returns true if the string matches the specified shell expression.</p>

<p><strong>Note that the patterns are <em>shell</em> glob <em>expressions</em>, not regular expressions. </strong><code>*</code> and <code>?</code> are always supported, while <code>[characters]</code> and <code>[^characters]</code> are supported by some implmentations including Firefox. This is mainly because the expression is translated to a RegExp via subsitution of <code>[.*?]</code>. For a reliable way to use these RegExp syntaxes, just use RegExp instead.</p>

<h4 id="Examples_8">Examples</h4>

<pre class="brush: js notranslate">shExpMatch("http://home.netscape.com/people/ari/index.html"     , "*/ari/*"); // returns true
shExpMatch("http://home.netscape.com/people/montulli/index.html", "*/ari/*"); // returns false</pre>

<h3 id="weekdayRange">weekdayRange()</h3>

<h4 id="Syntax_11">Syntax</h4>

<pre class="syntaxbox notranslate">weekdayRange(<var>wd1</var>, <var>wd2</var>, [<var>gmt</var>])</pre>

<div class="note">
<p><strong>Note:</strong> (Before Firefox 49) wd1 must be less than wd2 if you want the function to evaluate these parameters as a range. See the warning below.</p>
</div>

<h4 id="Parameters_12">Parameters</h4>

<dl>
 <dt>wd1 and wd2</dt>
 <dd>One of the ordered weekday strings:</dd>
 <dt>
 <pre class="syntaxbox notranslate">"SUN"|"MON"|"TUE"|"WED"|"THU"|"FRI"|"SAT"</pre>
 </dt>
 <dt>gmt</dt>
 <dd>Is either the string "GMT" or is left out.</dd>
</dl>

<p>Only the first parameter is mandatory. Either the second, the third, or both may be left out.</p>

<p>If only one parameter is present, the function returns a value of true on the weekday that the parameter represents. If the string "GMT" is specified as a second parameter, times are taken to be in GMT. Otherwise, they are assumed to be in the local timezone.</p>

<p>If both <strong>wd1 </strong>and <strong>wd1 </strong>are defined, the condition is true if the current weekday is in between those two <em>ordered </em>weekdays. Bounds are inclusive, <em>but the bounds are ordered</em>. If the "GMT" parameter is specified, times are taken to be in GMT. Otherwise, the local timezone is used.</p>

<div class="warning">
<p><strong>The order of the days matters</strong>; Before Firefox 49, <code>weekdayRange("<em>SUN", "SAT"</em>)</code> will always evaluate to true. Now <code>weekdayRange("<em>WED", "SUN"</em>)</code> will only evaluate true if the current day is Wednesday or Sunday.</p>
</div>

<h4 id="Examples_9">Examples</h4>

<pre class="brush: js notranslate">weekdayRange("MON", "FRI");        // returns true Monday through Friday (local timezone)
weekdayRange("MON", "FRI", "GMT"); // returns true Monday through Friday (GMT timezone)
weekdayRange("SAT");               // returns true on Saturdays local time
weekdayRange("SAT", "GMT");        // returns true on Saturdays GMT time
weekdayRange("FRI", "MON");        // returns true Friday and Monday only (note, order does matter!)</pre>

<h3 id="dateRange">dateRange()</h3>

<h4 id="Syntax_12">Syntax</h4>

<pre class="syntaxbox notranslate">dateRange(&lt;day&gt; | &lt;month&gt; | &lt;year&gt;, [gmt])  // ambiguity is resolved by assuming year is greater than 31
dateRange(&lt;day1&gt;, &lt;day2&gt;, [gmt])
dateRange(&lt;month1&gt;, &lt;month2&gt;, [gmt])
dateRange(&lt;year1&gt;, &lt;year2&gt;, [gmt])
dateRange(&lt;day1&gt;, &lt;month1&gt;, &lt;day2&gt;, &lt;month2&gt;, [gmt])
dateRange(&lt;month1&gt;, &lt;year1&gt;, &lt;month2&gt;, &lt;year2&gt;, [gmt])
dateRange(&lt;day1&gt;, &lt;month1&gt;, &lt;year1&gt;, &lt;day2&gt;, &lt;month2&gt;, &lt;year2&gt;, [gmt])</pre>

<div class="note">
<p><strong>Note:</strong> (Before Firefox 49) day1 must be less than day2, month1 must be less than month2, and year1 must be less than year2 if you want the function to evaluate these parameters as a range. See the warning below.</p>
</div>

<h4 id="Parameters_13">Parameters</h4>

<dl>
 <dt>day</dt>
 <dd>Is the ordered day of the month between 1 and 31 (as an integer).</dd>
</dl>

<pre class="syntaxbox notranslate">1|2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20|21|22|23|24|25|26|27|28|29|30|31</pre>

<dl>
 <dt>month</dt>
 <dd>Is one of the ordered month strings below.</dd>
</dl>

<pre class="syntaxbox notranslate">"JAN"|"FEB"|"MAR"|"APR"|"MAY"|"JUN"|"JUL"|"AUG"|"SEP"|"OCT"|"NOV"|"DEC"</pre>

<dl>
 <dt>year</dt>
 <dd>Is the ordered full year integer number. For example, 2016 (<strong>not</strong> 16).</dd>
 <dt>gmt</dt>
 <dd>Is either the string "GMT", which makes time comparison occur in GMT timezone, or is left out. If left unspecified, times are taken to be in the local timezone.</dd>
</dl>

<p>If only a single value is specified (from each category: day, month, year), the function returns a true value only on days that match that specification. If both values are specified, the result is true between those times, including bounds, <em>but the bounds are ordered</em>.</p>

<div class="warning">
<p><strong>The order of the days, months, and years matter</strong>; Before Firefox 49, <code>dateRange("<em>JAN", "DEC"</em>)</code> will always evaluate to <code>true</code>. Now <code>dateRange("<em>DEC", "JAN"</em>)</code> will only evaluate true if the current month is December or January.</p>
</div>

<h4 id="Examples_10">Examples</h4>

<pre class="brush: js notranslate">dateRange(1);            // returns true on the first day of each month, local timezone
dateRange(1, "GMT")      // returns true on the first day of each month, GMT timezone
dateRange(1, 15);        // returns true on the first half of each month
dateRange(24, "DEC");    // returns true on 24th of December each year
dateRange("JAN", "MAR"); // returns true on the first quarter of the year

dateRange(1, "JUN", 15, "AUG");
// returns true from June 1st until August 15th, each year
// (including June 1st and August 15th)

dateRange(1, "JUN", 1995, 15, "AUG", 1995);
// returns true from June 1st, 1995, until August 15th, same year

dateRange("OCT", 1995, "MAR", 1996);
// returns true from October 1995 until March 1996
// (including the entire month of October 1995 and March 1996)

dateRange(1995);
// returns true during the entire year of 1995

dateRange(1995, 1997);
// returns true from beginning of year 1995 until the end of year 1997</pre>

<h3 id="timeRange">timeRange()</h3>

<h4 id="Syntax_13">Syntax</h4>

<pre class="syntaxbox notranslate">// The full range of expansions is analogous to dateRange.
timeRange(&lt;hour1&gt;, &lt;min1&gt;, &lt;sec1&gt;, &lt;hour2&gt;, &lt;min2&gt;, &lt;sec2&gt;, [gmt])</pre>

<div class="note">
<p><strong>Note:</strong> (Before Firefox 49) the category hour1, min1, sec1 must be less than the category hour2, min2, sec2 if you want the function to evaluate these parameters as a range. See the warning below.</p>
</div>

<h4 id="Parameters_14">Parameters</h4>

<dl>
 <dt>hour</dt>
 <dd>Is the hour from 0 to 23. (0 is midnight, 23 is 11 pm.)</dd>
 <dt>min</dt>
 <dd>Minutes from 0 to 59.</dd>
 <dt>sec</dt>
 <dd>Seconds from 0 to 59.</dd>
 <dt>gmt</dt>
 <dd>Either the string "GMT" for GMT timezone, or not specified, for local timezone.</dd>
</dl>

<p>If only a single value is specified (from each category: hour, minute, second), the function returns a true value only at times that match that specification. If both values are specified, the result is true between those times, including bounds, <em>but the bounds are ordered</em>.</p>

<div class="warning">
<p><strong>The order of the hour, minute, second matter</strong>; Before Firefox 49, <code>timeRange(<em>0, 23</em>)</code> will always evaluate to true. Now <code>timeRange(<em>23, 0</em>)</code> will only evaluate true if the current hour is 23:00 or midnight.</p>
</div>

<h4 id="Examples_11">Examples</h4>

<pre class="brush: js notranslate">timerange(12);                // returns true from noon to 1pm
timerange(12, 13);            // returns true from noon to 1pm
timerange(12, "GMT");         // returns true from noon to 1pm, in GMT timezone
timerange(9, 17);             // returns true from 9am to 5pm
timerange(8, 30, 17, 00);     // returns true from 8:30am to 5:00pm
timerange(0, 0, 0, 0, 0, 30); // returns true between midnight and 30 seconds past midnight</pre>

<h2 id="Example_1">Example 1</h2>

<h3 id="Use_proxy_for_everything_except_local_hosts">Use proxy for everything except local hosts</h3>

<div class="note">
<p><strong>Note:</strong> Since all of the examples that follow are very specific, they have not been tested.</p>
</div>

<p>All hosts which aren't fully qualified, or the ones that are in local domain, will be connected to directly. Everything else will go through <code>w3proxy.mozilla.org:8080</code>. If the proxy goes down, connections become direct automatically:</p>

<pre class="brush: js notranslate">function FindProxyForURL(url, host) {
  if (isPlainHostName(host) || dnsDomainIs(host, ".mozilla.org")) {
    return "DIRECT";
  } else {
    return "PROXY w3proxy.mozilla.org:8080; DIRECT";
  }
}</pre>

<div class="note">
<p><strong>Note:</strong> This is the simplest and most efficient autoconfig file for cases where there's only one proxy.</p>
</div>

<h2 id="Example_2_2">Example 2</h2>

<h3 id="As_above_but_use_proxy_for_local_servers_which_are_outside_the_firewall">As above, but use proxy for local servers which are outside the firewall</h3>

<p>If there are hosts (such as the main Web server) that belong to the local domain but are outside the firewall and are only reachable through the proxy server, those exceptions can be handled using the <code>localHostOrDomainIs()</code> function:</p>

<pre class="brush: js notranslate">function FindProxyForURL(url, host) {
  if (
    (isPlainHostName(host) || dnsDomainIs(host, ".mozilla.org")) &amp;&amp;
    !localHostOrDomainIs(host, "www.mozilla.org") &amp;&amp;
    !localHostOrDoaminIs(host, "merchant.mozilla.org")
  ) {
    return "DIRECT";
  } else {
    return "PROXY w3proxy.mozilla.org:8080; DIRECT";
  }
}</pre>

<p>The above example will use the proxy for everything except local hosts in the mozilla.org domain, with the further exception that hosts <code>www.mozilla.org</code> and <code>merchant.mozilla.org</code> will go through the proxy.</p>

<div class="note">
<p><strong>Note</strong> the order of the above exceptions for efficiency: localHostOrDomainIs() functions only get executed for URLs that are in local domain, not for every URL. Be careful to note the parentheses around the<em> or</em> expression before the <em>and</em> expression to achieve the above-mentioned efficient behaviour.</p>
</div>

<h2 id="Example_3_2">Example 3</h2>

<h3 id="Use_proxy_only_if_cannot_resolve_host">Use proxy only if cannot resolve host</h3>

<p>This example will work in an environment where the internal DNS server is set up so that it can only resolve internal host names, and the goal is to use a proxy only for hosts that aren't resolvable:</p>

<pre class="brush: js notranslate">function FindProxyForURL(url, host) {
  if (isResolvable(host))
    return "DIRECT";
  else
    return "PROXY proxy.mydomain.com:8080";
}</pre>

<p>The above requires consulting the DNS every time; it can be grouped intelligently with other rules so that DNS is consulted only if other rules do not yield a result:</p>

<pre class="brush: js notranslate">function FindProxyForURL(url, host) {
  if (
    isPlainHostName(host) ||
    dnsDomainIs(host, ".mydomain.com") ||
    isResolvable(host)
  ) {
    return "DIRECT";
  } else {
    return "PROXY proxy.mydomain.com:8080";
  }
}</pre>

<h2 id="Example_4">Example 4</h2>

<h3 id="Subnet_based_decisions">Subnet based decisions</h3>

<p>In this example all of the hosts in a given subnet are connected-to directly, others are connected through the proxy:</p>

<pre class="brush: js notranslate">function FindProxyForURL(url, host) {
  if (isInNet(host, "198.95.0.0", "255.255.0.0"))
    return "DIRECT";
  else
    return "PROXY proxy.mydomain.com:8080";
}</pre>

<p>Again, use of the DNS server in the above can be minimized by adding redundant rules in the beginning:</p>

<pre class="brush: js notranslate">function FindProxyForURL(url, host) {
  if (
    isPlainHostName(host) ||
    dnsDomainIs(host, ".mydomain.com") ||
    isInNet(host, "198.95.0.0", "255.255.0.0")
  ) {
    return "DIRECT";
  } else {
    return "PROXY proxy.mydomain.com:8080";
  }
}</pre>

<h2 id="Example_5">Example 5</h2>

<h3 id="Load_balancingrouting_based_on_URL_patterns">Load balancing/routing based on URL patterns</h3>

<p>This example is more sophisticated. There are four (4) proxy servers; one of them is a hot stand-by for all of the other ones, so if any of the remaining three goes down the fourth one will take over. Furthermore, the three remaining proxy servers share the load based on URL patterns, which makes their caching more effective (there is only one copy of any document on the three servers - as opposed to one copy on each of them). The load is distributed like this:</p>

<table>
 <tbody>
  <tr>
   <th>Proxy</th>
   <th>Purpose</th>
  </tr>
  <tr>
   <td>#1</td>
   <td>.com domain</td>
  </tr>
  <tr>
   <td>#2</td>
   <td>.edu domain</td>
  </tr>
  <tr>
   <td>#3</td>
   <td>all other domains</td>
  </tr>
  <tr>
   <td>#4</td>
   <td>hot stand-by</td>
  </tr>
 </tbody>
</table>

<p>All local accesses are desired to be direct. All proxy servers run on the port 8080 (they don't need to, you can just change your port but remember to modify your configuations on both side). Note how strings can be concatenated with the <code><strong>+</strong></code> operator in JavaScript.</p>

<pre class="brush: js notranslate">function FindProxyForURL(url, host) {

  if (isPlainHostName(host) || dnsDomainIs(host, ".mydomain.com"))
    return "DIRECT";

  else if (shExpMatch(host, "*.com"))
    return "PROXY proxy1.mydomain.com:8080; " +
           "PROXY proxy4.mydomain.com:8080";

  else if (shExpMatch(host, "*.edu"))
    return "PROXY proxy2.mydomain.com:8080; " +
           "PROXY proxy4.mydomain.com:8080";

  else
    return "PROXY proxy3.mydomain.com:8080; " +
           "PROXY proxy4.mydomain.com:8080";
}</pre>

<h2 id="Example_6">Example 6</h2>

<h3 id="Setting_a_proxy_for_a_specific_protocol">Setting a proxy for a specific protocol</h3>

<p>Most of the standard JavaScript functionality is available for use in the <code>FindProxyForURL()</code> function. As an example, to set different proxies based on the protocol the {{jsxref("String.prototype.startsWith()", "startsWith()")}} function can be used:</p>

<pre class="brush: js notranslate">function FindProxyForURL(url, host) {

  if (url.startsWith("http:"))
    return "PROXY http-proxy.mydomain.com:8080";

  else if (url.startsWith("ftp:"))
    return "PROXY ftp-proxy.mydomain.com:8080";

  else if (url.startsWith(“gopher:"))
    return "PROXY gopher-proxy.mydomain.com:8080";

  else if (url.startsWith("https:") || url.startsWith("snews:"))
    return "PROXY security-proxy.mydomain.com:8080";

  else
    return "DIRECT";

}</pre>

<div class="note">
<p><strong>Note:</strong> The same can be accomplished using the <code><a href="#shExpMatch">shExpMatch()</a></code> function described earlier.</p>
</div>

<p>For example:</p>

<pre class="brush: js notranslate">// ...
if (shExpMatch(url, "http:*")) {
  return "PROXY http-proxy.mydomain.com:8080";
}
// ...</pre>

<div class="note">
<p>The autoconfig file can be output by a CGI script. This is useful, for example, when making the autoconfig file act differently based on the client IP address (the <code>REMOTE_ADDR</code> environment variable in CGI).</p>

<p>Usage of <code>isInNet()</code>, <code>isResolvable()</code> and <code>dnsResolve()</code> functions should be carefully considered, as they require the DNS server to be consulted. All the other autoconfig-related functions are mere string-matching functions that don't require the use of a DNS server. If a proxy is used, the proxy will perform its DNS lookup which would double the impact on the DNS server. Most of the time these functions are not necessary to achieve the desired result.</p>
</div>

<h2 id="History_and_implementation">History and implementation</h2>

<p>Proxy auto-config was introduced into Netscape Navigator 2.0 in the late 1990s, at the same time when JavaScript was introduced. Open-sourcing Netscape eventually lead to Firefox itself.</p>

<p>The most "original" implementation of PAC and its JavaScript libraries is, therefore, <code>nsProxyAutoConfig.js</code> found in early versions of Firefox. These utilities are found in many other open-source systems including <a href="https://cs.chromium.org/chromium/src/services/proxy_resolver/pac_js_library.h">Chromium</a>. Firefox later integrated the file into <code><a href="https://dxr.mozilla.org/mozilla-central/source/netwerk/base/ProxyAutoConfig.cpp">ProxyAutoConfig.cpp</a></code> as a C++ string literal. To extract it into its own file, it suffices to copy the chunk into JavaScript with a <code>console.log</code> directive to print it.</p>

<p>Microsoft in general made its own implementation. There used to be <a href="https://en.wikipedia.org/wiki/Proxy_auto-config#Old_Microsoft_problems">some problems with their libraries</a>, but most are resolved by now. They have defined <a href="https://docs.microsoft.com/en-us/windows/win32/winhttp/ipv6-extensions-to-navigator-auto-config-file-format">some new "Ex" suffixed functions</a> around the address handling parts to support IPv6. The feature is supported by Chromium, but not yet by Firefox (<a href="https://bugzilla.mozilla.org/show_bug.cgi?id=558253">bugzilla #558253</a>).</p>
